echo "Random reads/writes"
echo
:>"experiments/results/threshold/random.csv"


for i in 5 10 20 30 40 50
do

rtc_throughput=0
rtcdd_throughput=0
rtcdd_num_in_sec=0
rtc2dd_throughput=0	

for (( j = 1 ; j <= 5; j++ ))
do
	export STM_CONFIG=RTC
	result=$(echo "$(./../rstm_build/bench/ReadWriteNBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtc_throughput=`expr $temp + $rtc_throughput`

	export STM_CONFIG=RTCDD
	result=$(echo "$(./../rstm_build/bench/ReadWriteNBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtcdd_throughput=`expr $temp + $rtcdd_throughput`
	temp=$(echo $result | egrep -e 'Number of transactions in secondary server =[^ ]*' -o | cut -d = -f 2)
	rtcdd_num_in_sec=`expr $temp + $rtcdd_num_in_sec`

	export STM_CONFIG=RTC2DD
	result=$(echo "$(./../rstm_build/bench/ReadWriteNBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtc2dd_throughput=`expr $temp + $rtc2dd_throughput`


done

	rtc_throughput=`expr $rtc_throughput / 5`
	rtcdd_throughput=`expr $rtcdd_throughput / 5`
	rtcdd_num_in_sec=`expr $rtcdd_num_in_sec / 5`
	rtc2dd_throughput=`expr $rtc2dd_throughput / 5`
	rtcdd_improvement=$(echo $rtcdd_throughput $rtc_throughput | awk ' { printf "%f\n", ($1 - $2) / $2 } ')
	rtc2dd_improvement=$(echo $rtc2dd_throughput $rtc_throughput | awk ' { printf "%f\n", ($1 - $2) / $2 } ')
	rtcdd_perc_in_sec=$(echo $rtcdd_num_in_sec $rtcdd_throughput | awk ' { printf "%f\n", $1 / $2 } ')

	echo "Size of transaction: " $i
	echo "RTC: " $rtc_throughput
	echo "RTCDD: " $rtcdd_throughput	
	echo "RTC2DD: " $rtc2dd_throughput	
	echo "RTCDD-Sec:" $rtcdd_num_in_sec
	echo "Improvement of one DD: " $rtcdd_improvement
	echo "Improvement of two DD: " $rtc2dd_improvement
	echo "Percentage in DD server: " $rtcdd_perc_in_sec
	echo

	echo $i $rtcdd_improvement $rtc2dd_improvement $rtcdd_perc_in_sec >> "experiments/results/threshold/random.csv"
	
done
#=============================================================================================================================================

echo "Dependent reads/writes"
echo
:>"experiments/results/threshold/dependent.csv"


for i in 5 10 20 30 40 50
do

rtc_throughput=0
rtcdd_throughput=0
rtcdd_num_in_sec=0
rtc2dd_throughput=0	

for (( j = 1 ; j <= 5; j++ ))
do
	export STM_CONFIG=RTC
	result=$(echo "$(./../rstm_build/bench/RWDependentBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtc_throughput=`expr $temp + $rtc_throughput`

	export STM_CONFIG=RTCDD
	result=$(echo "$(./../rstm_build/bench/RWDependentBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtcdd_throughput=`expr $temp + $rtcdd_throughput`
	temp=$(echo $result | egrep -e 'Number of transactions in secondary server =[^ ]*' -o | cut -d = -f 2)
	rtcdd_num_in_sec=`expr $temp + $rtcdd_num_in_sec`

	export STM_CONFIG=RTC2DD
	result=$(echo "$(./../rstm_build/bench/RWDependentBenchSSB64 -p 60 -m 10000000 -O $i -N $i)")
	temp=$(echo $result | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)
	rtc2dd_throughput=`expr $temp + $rtc2dd_throughput`


done

	rtc_throughput=`expr $rtc_throughput / 5`
	rtcdd_throughput=`expr $rtcdd_throughput / 5`
	rtcdd_num_in_sec=`expr $rtcdd_num_in_sec / 5`
	rtc2dd_throughput=`expr $rtc2dd_throughput / 5`
	rtcdd_improvement=$(echo $rtcdd_throughput $rtc_throughput | awk ' { printf "%f\n", ($1 - $2) / $2 } ')
	rtc2dd_improvement=$(echo $rtc2dd_throughput $rtc_throughput | awk ' { printf "%f\n", ($1 - $2) / $2 } ')
	rtcdd_perc_in_sec=$(echo $rtcdd_num_in_sec $rtcdd_throughput | awk ' { printf "%f\n", $1 / $2 } ')

	echo "Size of transaction: " $i
	echo "RTC: " $rtc_throughput
	echo "RTCDD: " $rtcdd_throughput
	echo "RTC2DD: " $rtc2dd_throughput	
	echo "RTCDD-Sec:" $rtcdd_num_in_sec
	echo "Improvement of one DD: " $rtcdd_improvement
	echo "Improvement of two DD: " $rtc2dd_improvement
	echo "Percentage in DD server: " $rtcdd_perc_in_sec
	echo

	echo $i $rtcdd_improvement $rtc2dd_improvement $rtcdd_perc_in_sec >> "experiments/results/threshold/dependent.csv"
	
done
#=============================================================================================================================================
